<?php
/**************************************************************
Skull-Splitter's PHP Photos
Copyright (C) 2005  Soeren Boysen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**************************************************************/


/* Setup */
require 'libs/Smarty.class.php';
$smarty = new Smarty;

/*********************************************/

include "includes/functions.inc.php";
include "includes/config.inc.php";

/*********************************************/

$event    = $_GET["event"];
$mode     = $_GET["mode"];
$row      = $_GET["row"];
$column   = $_GET["column"];

/*********************************************/

$smarty->assign('path', $path);   // Make photo-path available to template

$event = !isset($_GET['event'])?"":$_GET['event']; // Make sure that $event is set
$smarty->assign('event', $event);   // Make event variable available to template

$allPhotos = prepPhotoArray($path,"text.php");
$eventNames = stripDirNames($allPhotos);
$smarty->assign('eventNames', $eventNames);   // Make eventNames array available to template

if($event != "")    // If an event has been selected
  {
    // Include file with message at the top and bottom of the page
    if(is_file($path."/".$event."/text.php"))
      {
        include $path."/".$event."/text.php";
        $smarty->assign('messageTop', $messageTop);
        $smarty->assign('messageBottom', $messageBottom);
      }
    
    // If event is selected, copy the event's photos into new array
    $eventPhotos = array();
    for($i=0; $allPhotos[$event][$i] != ""; $i++)
      {
        $eventPhotos[$event][$i] = $allPhotos[$event][$i];
      }
    sort($eventPhotos[$event], SORT_STRING);
    $eventPhotos = array_chunk($eventPhotos[$event], $photosPerRow);
    $smarty->assign('photos', $eventPhotos);    // Make photo-array available to template
    $smarty->assign('allPhotos', $allPhotos);   // Make all photos-array available to template
    
    //*** Calculate dimensions of image & window
    //
      if(is_file($path."/".$event."/".$eventPhotos[$row - 1][$column - 1]))
        {
          $imageinfo = getimagesize($path."/".$event."/".$eventPhotos[$row - 1][$column - 1]);

          // If image dimensions are bigger than the maximum values set in the config file, then
          // fit them to the maximum.
          
          $dim_attrib = "";
          
          if( ($imageinfo[0] > $preview_max_dim_x) && ($imageinfo[1] > $preview_max_dim_y) )
            {
              if( ($imageinfo[0] - $preview_max_dim_x) > ($imageinfo[1] - $preview_max_dim_y) )
                {
                  $preview_dim_x = $preview_max_dim_x;
                  $dim_attrib = $dim_attrib." width=\"".$preview_dim_x."\" ";
                }
              else
                {
                  $preview_dim_y = $preview_max_dim_y;
                  $dim_attrib = $dim_attrib." height=\"".$preview_dim_y."\" ";
                }
            }
          else
            {
              if($imageinfo[0] > $preview_max_dim_x)
                {
                  $preview_dim_x = $preview_max_dim_x;
                  $dim_attrib = $dim_attrib." width=\"".$preview_dim_x."\" ";
                }

              if($imageinfo[1] > $preview_max_dim_y)
                {
                  $preview_dim_y = $preview_max_dim_y;
                  $dim_attrib = $dim_attrib." height=\"".$preview_dim_y."\" ";
                }
            }
          
          $smarty->assign('dim_attrib', $dim_attrib);
          $smarty->assign('preview_max_dim_x', $preview_max_dim_x);
          $smarty->assign('preview_max_dim_y', $preview_max_dim_y);
        }
      
      $smarty->assign('preview_win_x', $preview_win_x);
      $smarty->assign('preview_win_y', $preview_win_y);
    //
    //******//
    
    $smarty->assign('row', $row - 1);           // Current photo - find row index from physical row
    $smarty->assign('column', $column - 1);     // Current photo - find column index from physical column
    
    //*** Calculate # of current photo
    //
      $numCurrentPic = ( ($row - 1) * $photosPerRow ) + $column;
      $smarty->assign('numCurrentPic', $numCurrentPic);
    //
    //******//
    
    //*** Previous photo - find row and column index
    //
      $prevPicRow = $row;
      $prevPicColumn = $column;
      
      if($column == 1)
        {
          $prevPicRow--;
          $prevPicColumn = $photosPerRow;
        }
      else
        {
          $prevPicColumn--;
        }
      $smarty->assign('prevPicRow', $prevPicRow);
      $smarty->assign('prevPicColumn', $prevPicColumn);
    //
    //******//
    
    //*** Next photo - find row and column index
    //
      $nextPicRow = $row;
      $nextPicColumn = $column;
      
      if($column == $photosPerRow)
        {
          $nextPicRow++;
          $nextPicColumn = 1;
        }
      else
        {
          $nextPicColumn++;
        }
      $smarty->assign('nextPicRow', $nextPicRow);
      $smarty->assign('nextPicColumn', $nextPicColumn);
    //
    //******//
    
    $numPics = sizeof($allPhotos[$event]) - 1;  // -1 because the sub-directory /thumbs is being counted as well
    $smarty->assign('numPics', $numPics);
  }
else
  {
    uksort($allPhotos, 'strnatcasecmp');
    $allPhotos = array_reverse($allPhotos, TRUE);
    $smarty->assign('photos', $allPhotos);   // Make photo-array available to template
  }

/*********************************************/

/* Output to template */
If($event == "")
  {
    $smarty->display('list_events.tpl');   // output the list events page
  }
Else
  {
    If($mode != "viewphoto" or !isset($mode))
      {
        $smarty->display('view_event.tpl');   // output the view event page
      }
    Else
      {
        $smarty->display('view_photo.tpl');   // output the view photo page
      }
  }


?>